#ifndef HASH_FN_H
#define HASH_FN_H

#include"key.h"

#include<stddef.h>

int mhash(key_t key,size_t size);
int rhash(key_t key,size_t size);
int bhash(key_t key,size_t size);
int phash(key_t key,size_t size);
int dhash(key_t key,size_t size);

#define RHOCCU (.92)
int rehashstep;
#define rehashstep0(key,size) (1 + ((key) % ((size) - 1)))
#define rehashstep1(size) ((size) << 1)
int rehash0(key_t key,size_t size);
int rehash1(key_t key,size_t size);
int rehash2(key_t key,size_t size);
int rehash3(key_t key,size_t size);
int rehash4(key_t key,size_t size);
int rehash5(key_t key,size_t size);
int rehash6(key_t key,size_t size);

#define PRHOCCU (.90)
int prehashstep;
int prehash0(key_t key,size_t size);

#endif
