#include"key.h"
#include"bnb.h"
#include<limits.h>

#define STRTOKEYMIN (1234)

key_t strtokey(char *string) {
         int len;
         key_t key;

         key = 0;
         for(len = 0; string[len] && len < STRTOKEYLEN;len++) {
            key ^= (1 << (string[len] % (IBITS)));
            key ^= (1 << (string[len] / (IBITS)));
         }
         key += STRTOKEYMIN;
         return key;
      }

int adctrn(int letter) {
  int trn;

	  if(ctrnorder >= ADICTRN) {
	  if(isdigit(letter)) {
		 trn = letter - '0' + CTRNMIN;
		 if((ctrnorder - ADICTRN) >= 2) 
				 trn += 26;
	  }
	  else {
		 if(isalpha(letter)) {
			 trn = tolower(letter) - 'a' + CTRNMIN;
			 if((ctrnorder - ADICTRN) <= 2)
				  trn += 10;
		 }
		 else
			 trn = CTRNMIN - 1;
	}
        }
	 else {
		if(isdigit(letter)) {
			 trn = letter - '0' + CTRNMIN;
			 if(ctrnorder >= 2) trn += 52;
		}
		 else {
			if(isupper(letter)) {
				trn = letter - 'A' + CTRNMIN;
				if(ctrnorder == 0)
				   trn += 36;
				else
				   if(ctrnorder != 3)
					  trn += 26;
			}
			else {
				 if(islower(letter)) {
					trn = letter - 'a' + CTRNMIN;
					if(ctrnorder == 1)
						trn += 36;
					else
						if(ctrnorder != 2)
							trn += 26;
				}
				else
					trn = CTRNMIN - 1;
			   }
		 }
	 }
	  return trn;
	}

char str[STRTOKEYLEN];
key_t ostrtokey(char *string) {
		  int alpha;
		  key_t max;
		  long double key = 0;

                  for(alpha = 0;*string && alpha < STRTOKEYLEN;string++)
		   if((str[alpha] = ctrn(*string)) >= CTRNMIN)
			   alpha++;
		  if(alpha == STRTOKEYLEN) {
			 --alpha;
			 key = ((long double)str[alpha])/
				   ((ctrnmax >> 2) + 1);
			 max = 3;
		   }
		   else {
			key = 0;
			max = (allones(STRTOKEYLEN - alpha + 1));
	           }
		while((--alpha) >= 0) {
			key = (2 * ((((long double)max) * 
             (long double)str[alpha]) + key)) / ((long double)(ctrnmax + 1));
			max = (max << 1) + 1;
		}
		return (key_t)floor(key + .5);
	 }
 
key_t ovstrtokey(char *string,long double *ratio) {
		  int alpha;
		  key_t max;
		  long double key,ratio1;

			for(alpha = 0;*string && alpha < STRTOKEYLEN;string++)
			   if((str[alpha] = ctrn(*string)) >= CTRNMIN)
					   alpha++;
			if(alpha == STRTOKEYLEN) {
				 --alpha;
			 key = floor((((long double)str[alpha])) /
					((ctrnmax >> 2) + 1));
			 max = 3;
			}
			else {
				key = 0;
			}
			while((--alpha) >= 0) {
				ratio1 = ((! alpha) ? 1 : ratio[alpha - 1]) /
					(ratio[alpha] * (ctrnmax + 1));
				key = ratio1 * ((UINT_MAX * ratio[alpha] * str[alpha])
							 + key);
			}
			return (key_t)floor(key + .5);
		 } 
